Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Imports Infragistics.WebUI
Imports System.Threading.Thread
Imports Infragistics.WebUI.UltraWebGrid
Imports common
Imports System.Diagnostics
Imports System.IO
Imports System.Runtime.InteropServices.Marshal
Imports Excel = Microsoft.Office.Interop.Excel
Imports Infragistics.Excel.ExcelDefaultableBoolean

Partial Class _Default
    Inherits System.Web.UI.Page

    Dim activeRow As UltraGridRow
    Dim ar As ArrayList

    Protected Sub uwgPending_InitializeLayout(ByVal sender As Object, ByVal e As Infragistics.WebUI.UltraWebGrid.LayoutEventArgs) Handles uwgPending.InitializeLayout
        activeRow = e.Layout.ActiveRow
        If Not activeRow Is Nothing Then
            If activeRow.Selected = False Then
                activeRow.Selected = True
            Else
                activeRow.Selected = False
            End If
        End If
    End Sub

    Protected Sub uwgCompletedNA_InitializeLayout(ByVal sender As Object, ByVal e As Infragistics.WebUI.UltraWebGrid.LayoutEventArgs) Handles uwgCompletedNA.InitializeLayout
        With e.Layout.Bands(0).Columns.FromKey("item_group_desc")
            .Width = Unit.Pixel(100)
            .AllowUpdate = Infragistics.WebUI.UltraWebGrid.AllowUpdate.No
            .IsGroupByColumn = True
        End With

        e.Layout.AllowSortingDefault = AllowSorting.Yes

        activeRow = e.Layout.ActiveRow
        If Not activeRow Is Nothing Then
            If activeRow.Selected = False Then
                activeRow.Selected = True
            Else
                activeRow.Selected = False
            End If
        End If

    End Sub

    Protected Sub uwgPending_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles uwgPending.PreRender
        If Not IsPostBack Then
            Dim col1 As UltraGridColumn = uwgPending.Bands(0).Columns.FromKey("group_order")
            Dim col2 As UltraGridColumn = uwgPending.Bands(0).Columns.FromKey("category_order")

            col1.SortIndicator = SortIndicator.Ascending
            col2.SortIndicator = SortIndicator.Ascending

            With uwgPending.Bands(0).SortedColumns
                .Add(col1)
                .Add(col2)
            End With
        End If

    End Sub

    Protected Sub uwgPending_UpdateRow(ByVal sender As Object, ByVal e As Infragistics.WebUI.UltraWebGrid.RowEventArgs) Handles uwgPending.UpdateRow
        If e.Row.DataChanged Then
            With sds_input_p
                .UpdateParameters("input_id").DefaultValue = e.Row.Cells.FromKey("input_id").Value
                .UpdateParameters("input_applicable").DefaultValue = e.Row.Cells.FromKey("input_applicable").Value
                If e.Row.Cells.FromKey("input_reviewed_date").Value Is Nothing Then
                    .UpdateParameters("input_reviewed_date").DefaultValue = DBNull.Value.ToString
                    .UpdateParameters("input_reviewed_date").ConvertEmptyStringToNull = True
                Else
                    .UpdateParameters("input_reviewed_date").DefaultValue = e.Row.Cells.FromKey("input_reviewed_date").Value
                End If
                If e.Row.Cells.FromKey("input_compliance_date").Value Is Nothing Then
                    .UpdateParameters("input_compliance_date").DefaultValue = DBNull.Value.ToString
                    .UpdateParameters("input_compliance_date").ConvertEmptyStringToNull = True
                Else
                    .UpdateParameters("input_compliance_date").DefaultValue = e.Row.Cells.FromKey("input_compliance_date").Value
                End If
                .UpdateParameters("input_response").DefaultValue = e.Row.Cells.FromKey("input_response").Text
                .UpdateParameters("input_person_id").DefaultValue = e.Row.Cells.FromKey("input_person_id").Text
                .UpdateParameters("input_ops").DefaultValue = e.Row.Cells.FromKey("input_ops").Value
                If e.Row.Cells.FromKey("input_ops_date").Value Is Nothing Then
                    .UpdateParameters("input_ops_date").DefaultValue = DBNull.Value.ToString
                    .UpdateParameters("input_ops_date").ConvertEmptyStringToNull = True
                Else
                    .UpdateParameters("input_ops_date").DefaultValue = e.Row.Cells.FromKey("input_ops_date").Value
                End If
                .UpdateParameters("user_id").DefaultValue = windows_user_id()
                .Update()
            End With
        End If

    End Sub

    Protected Sub uwgCompletedNA_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles uwgCompletedNA.PreRender
        Dim col1 As UltraGridColumn = uwgCompletedNA.Bands(0).Columns.FromKey("group_order")
        Dim col2 As UltraGridColumn = uwgCompletedNA.Bands(0).Columns.FromKey("category_order")

        col1.SortIndicator = SortIndicator.Ascending
        col2.SortIndicator = SortIndicator.Ascending

        With uwgCompletedNA.Bands(0).SortedColumns
            .Add(col1)
            .Add(col2)
        End With

    End Sub

    Protected Sub uwgCompletedNA_UpdateRow(ByVal sender As Object, ByVal e As Infragistics.WebUI.UltraWebGrid.RowEventArgs) Handles uwgCompletedNA.UpdateRow
        If e.Row.DataChanged Then
            With sds_input_c
                .UpdateParameters("input_id").DefaultValue = e.Row.Cells.FromKey("input_id").Value
                .UpdateParameters("input_applicable").DefaultValue = e.Row.Cells.FromKey("input_applicable").Value
                If e.Row.Cells.FromKey("input_reviewed_date").Value Is Nothing Then
                    .UpdateParameters("input_reviewed_date").DefaultValue = DBNull.Value.ToString
                    .UpdateParameters("input_reviewed_date").ConvertEmptyStringToNull = True
                Else
                    .UpdateParameters("input_reviewed_date").DefaultValue = e.Row.Cells.FromKey("input_reviewed_date").Value
                End If
                If e.Row.Cells.FromKey("input_compliance_date").Value Is Nothing Then
                    .UpdateParameters("input_compliance_date").DefaultValue = DBNull.Value.ToString
                    .UpdateParameters("input_compliance_date").ConvertEmptyStringToNull = True
                Else
                    .UpdateParameters("input_compliance_date").DefaultValue = e.Row.Cells.FromKey("input_compliance_date").Value
                End If
                .UpdateParameters("input_response").DefaultValue = e.Row.Cells.FromKey("input_response").Text
                .UpdateParameters("input_person_id").DefaultValue = e.Row.Cells.FromKey("input_person_id").Text
                .UpdateParameters("input_ops").DefaultValue = e.Row.Cells.FromKey("input_ops").Value
                If e.Row.Cells.FromKey("input_ops_date").Value Is Nothing Then
                    .UpdateParameters("input_ops_date").DefaultValue = DBNull.Value.ToString
                    .UpdateParameters("input_ops_date").ConvertEmptyStringToNull = True
                Else
                    .UpdateParameters("input_ops_date").DefaultValue = e.Row.Cells.FromKey("input_ops_date").Value
                End If
                .UpdateParameters("user_id").DefaultValue = windows_user_id()
                .Update()
            End With
        End If

    End Sub

    Public Function windows_user_id() As String
        Dim user_id As String = CurrentPrincipal.Identity.Name
        Return user_id.Substring(user_id.IndexOf("\") + 1)
    End Function

    Protected Sub page_load(ByVal sender As Object, ByVal events As EventArgs) Handles Me.Load
        If Not (is_user() Or is_admin()) Then
            Response.Redirect("~/unauthorized.aspx")
        End If
        CurrentThread.CurrentCulture = New System.Globalization.CultureInfo("en-US")
        If is_admin() Then
            hyp_admin.Visible = True
        End If

        ddl_BU.Attributes.Add("OnChange", "BU_Change();")

    End Sub

    Protected Function GetValue(ByVal value As String) As String
        If value = "True" Then
            Return "Yes"
        ElseIf value = "False" Then
            Return "No"
        Else
            Return DBNull.Value.ToString
        End If

    End Function

    Public Function is_admin() As Boolean
        Return CurrentPrincipal.IsInRole("KM\MRV_Admin")
    End Function

    Public Function is_user() As Boolean
        Return is_admin() Or CurrentPrincipal.IsInRole("KM\MRV_User")
    End Function

    Protected Sub btn_download_ServerClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles btn_download.ServerClick
        Dim file_path_name As String
        file_path_name = extract_input_data(ddl_BU.SelectedValue)
        'Response.Redirect("http://localhost/MRV_ExcelTemplates/" & file_path_name)
        'Response.End()

    End Sub

    Protected Function extract_input_data(ByVal int_bu_id As Integer) As String

        Dim str_process As String = Nothing
        Dim str_message As String = Nothing

        '****************************************************************************************************
        ' Select Employee Data into a Data Table

        'Dim cn As New SqlConnection(str_cn)
        Dim cn As New SqlConnection(ConfigurationManager.ConnectionStrings("MRVConnectionString").ToString)
        Dim cmd As New SqlCommand
        Dim da As New SqlDataAdapter
        Dim dt As New DataTable

        Try
            'Open Connection
            cn.Open()

            'Build Command
            cmd.Connection = cn
            cmd.CommandText = "sp_input_extract"
            cmd.CommandType = CommandType.StoredProcedure
            cmd.Parameters.AddWithValue("@bus_unit", int_bu_id)

            'Execute Command with Data Adapter and fill Data Table
            da.SelectCommand = cmd
            da.Fill(dt)
            If (dt.Rows.Count = 0) Then
                dt.Dispose()
                Return Nothing
            End If

        Catch ex As SqlException
            'Catch SQL Exception as Error
            str_message = "Process: " & str_process _
                & Chr(13) & "Error Step: Extract Data" _
                & Chr(13) & "Error Type: SQL (" & ex.Number & ")" _
                & Chr(13) & "Error: " & ex.Message.ToString
            'log_message(str_message, MsgType.Error) '************************************
            Return Nothing

        Catch ex As Exception
            'Catch General Exception as Error
            str_message = "Process: " & str_process _
                & Chr(13) & "Error Step: Extract Data" _
                & Chr(13) & "Error Type: General" _
                & Chr(13) & "Error: " & ex.Message.ToString
            'log_message(str_message, MsgType.Error) '************************************
            Return Nothing

        Finally
            'Dispose of the DataAdapter
            da.Dispose()

            'Dispose of the Command
            cmd.Dispose()

            'Close the Connection
            cn.Close()

        End Try

        '****************************************************************************************************
        ' Build Excel Input Upload File from Data Table

        'File System Variables
        Dim var_file_delim = Nothing

        Dim col As Integer
        Dim row As Integer
        Dim rows As DataRow

        row = 1

        'Dim xlApp As Infragistics.Excel.Application
        Dim xlWorkBook As New Infragistics.Excel.Workbook
        Dim xlWorkSheet As Infragistics.Excel.Worksheet
        Dim misValue As Object = System.Reflection.Missing.Value

        'xlApp = New Excel.ApplicationClass
        'xlWorkBook = xlApp.Workbooks.Add(misValue)
        xlWorkBook.Worksheets.Add("sheet1")
        xlWorkSheet = xlWorkBook.Worksheets("sheet1")

        Dim str_file_date As String = String.Format(Now(), "_yyyyMMdd_HHmmss")
        Dim str_file_name As String = "Test" & str_file_date & ".xls"
        Dim str_file_path As String = "c:\MRV_ExcelTemplates\" & str_file_name

        Try
            'Write Headers
            For col = 0 To dt.Columns.Count - 1
                xlWorkSheet.Rows(0).Cells(col).Value = dt.Columns(col).ColumnName
                xlWorkSheet.Rows(0).Cells(col).CellFormat.Font.Bold = [True]
                With xlWorkSheet.Rows(0).Cells(col).CellFormat
                    '.FillPattern = Infragistics.Excel.FillPatternStyle.Solid
                    .BottomBorderStyle = Infragistics.Excel.CellBorderLineStyle.Medium
                    .BottomBorderColor = Drawing.Color.Black
                    '.FillPatternBackgroundColor = Drawing.Color.LightGray
                    .Locked = [True]
                End With
                If xlWorkSheet.Rows(0).Cells(col).Value = "input_id" Or xlWorkSheet.Rows(0).Cells(col).Value = "input_business_unit_id" Then
                    xlWorkSheet.Columns(col).Width = 0
                End If
                'xlWorkSheet.Cells(1, col + 1) = (dt.Columns(col).ColumnName)
                'xlWorkSheet.Cells(1, col + 1).Font.Bold = True
                'xlWorkSheet.Cells(1, col + 1).Borders.LineStyle = 1 'xlContinuous
                'xlWorkSheet.Cells(1, col + 1).Borders.ColorIndex = 0
                'xlWorkSheet.Cells(1, col + 1).Borders.TintAndShade = 0
                'xlWorkSheet.Cells(1, col + 1).Borders.Weight = 2 'xlThin
                'xlWorkSheet.Cells(1, col + 1).Interior.Pattern = 1
                'xlWorkSheet.Cells(1, col + 1).Interior.PatternColorIndex = -4105 'xlSolid
                'xlWorkSheet.Cells(1, col + 1).Interior.TintAndShade = -0.149998474074526
                'xlWorkSheet.Cells(1, col + 1).Interior.PatternTintAndShade = 0
                'xlWorkSheet.Cells(1, col + 1).Locked = True
            Next

            'Write Rows
            For Each rows In dt.Rows
                For col = 0 To dt.Columns.Count - 1
                    xlWorkSheet.Rows(row).Cells(col).Value = rows.Item(col).ToString
                    'xlWorkSheet.Cells(row, col + 1) = rows.Item(col).ToString
                Next
                row = row + 1
            Next

            'Set Vertical Align
            'xlWorkSheet.Columns("A:T").VerticalAlignment = -4160 'xlVAlignTop
            'xlWorkSheet.Rows().Locked = False

            ''Set Column Widths
            'xlWorkSheet.Columns("A:D").EntireColumn.AutoFit()
            'xlWorkSheet.Columns("E:H").ColumnWidth = 60
            'xlWorkSheet.Columns("I:K").EntireColumn.AutoFit()
            'xlWorkSheet.Columns("L:M").ColumnWidth = 0 'Hidden Fields
            'xlWorkSheet.Columns("N:Q").EntireColumn.AutoFit()
            'xlWorkSheet.Columns("R:R").ColumnWidth = 60
            'xlWorkSheet.Columns("S:T").EntireColumn.AutoFit()

            ''Set Text Wrapping
            'xlWorkSheet.Columns("A:D").WrapText = False
            'xlWorkSheet.Columns("E:H").WrapText = True
            'xlWorkSheet.Columns("I:Q").WrapText = False
            'xlWorkSheet.Columns("R:R").WrapText = True
            'xlWorkSheet.Columns("S:T").WrapText = False

            ''Set Column Format
            'xlWorkSheet.Columns("I:K").NumberFormat = "mm/dd/yyyy;@"
            'xlWorkSheet.Columns("O:P").NumberFormat = "mm/dd/yyyy;@"
            'xlWorkSheet.Columns("T:T").NumberFormat = "mm/dd/yyyy;@"

            ''Set Font Color
            'xlWorkSheet.Columns("A:K").Font.Color = 0 'Black
            'xlWorkSheet.Columns("L:M").Font.Color = 255 'Red - Hidden Fields
            'xlWorkSheet.Columns("N:T").Font.Color = 13382400 'Blue

            'Freeze Panels
            'xlApp.ActiveWindow.SplitColumn = 0
            'xlApp.ActiveWindow.SplitRow = 1
            'xlApp.ActiveWindow.FreezePanes = True

            'Set Cell
            'xlWorkSheet.Range("A2").Select()

            'Set Worksheet Name
            xlWorkSheet.Name = "Input Upload"

            'Delete Extra Sheets
            Dim work2 As Excel.Worksheet = xlWorkBook.Worksheets("sheet2")
            work2.Delete()
            'xlApp.ActiveWindow.SelectedSheets.Delete()
            Dim work3 As Excel.Worksheet = xlWorkBook.Worksheets("sheet3")
            work3.Delete()
            'xlWorkBook.Sheets("sheet3").Select()
            'xlApp.ActiveWindow.SelectedSheets.Delete()

            'Protect Sheet
            'xlWorkSheet.Protected = True

            'xlWorkSheet.Protect("lock", , , , , , , True, , , , , True, True, , ) 'Allow Row Edit/Delete and Sort ONLY

            'Open Excel Application
            'xlApp.Visible = True


        Catch ex As IOException
            'Catch File IO Exception as Error
            str_message = "Process: " & str_process _
                & Chr(13) & "Error Step: Build File" _
                & Chr(13) & "Error Type: File IO" _
                & Chr(13) & "Error: " & ex.Message.ToString
            'log_message(str_message, MsgType.Error) '************************************
            Return Nothing

        Catch ex As Exception
            'Catch Exception as Error
            str_message = "Process: " & str_process _
                & Chr(13) & "Error Step: Build File" _
                & Chr(13) & "Error Type: File Create" _
                & Chr(13) & "Error: " & ex.Message.ToString
            'log_message(str_message, MsgType.Error) '************************************
            Return Nothing

        Finally
            'Save File
            'xlWorkSheet.SaveAs(str_file_path)

            ExportToExcel(Page, xlWorkBook, "Input Upload", str_file_name)

            'Close Workbook
            'xlWorkBook..Close()

            'Quit Excel
            'xlApp.Quit()

            'Release Objects
            'ReleaseComObject(xlApp)
            'ReleaseComObject(xlWorkBook)
            'ReleaseComObject(xlWorkSheet)

            'Dispose of the DataTable
            dt.Dispose()

        End Try

        Return str_file_name

    End Function

End Class